<script lang="ts">
	import { Button, Card } from 'flowbite-svelte';
	import type { Certification } from '$lib/objects/Certification';
	import type { CompanyExperience } from '$lib/objects/Experience';
	import { loadCertifications, loadExperiences } from '$lib/data/loaders';
	import CertificationCard from '$lib/components/CertificationCard.svelte';
	import FilterTags from '$lib/components/FilterTags.svelte';

	let certifications = $state<Certification[]>([]);
	let experiences = $state<CompanyExperience[]>([]);
	let filteredExperiences = $state<CompanyExperience[]>([]);
	let allTags = $state<string[]>([]);
	let selectedTags = $state<string[]>([]);

	const resumes = [
		{ title: 'All Experience', url: '/resumes/AlexandreAlves.pdf' },
	];

	$effect(() => {
		(async () => {
			try {
				const [certsData, expData] = await Promise.all([loadCertifications(), loadExperiences()]);

				certifications = certsData;
				experiences = expData;

				// Extract all unique tags from experiences
				const tagSet = new Set<string>();
				experiences.forEach((company) => {
					company.positions.forEach((position) => {
						position.tags?.forEach((tag) => tagSet.add(tag));
					});
				});
				allTags = Array.from(tagSet).sort();

				// Initialize filtered experiences
				updateFilteredExperiences();

				console.log(certifications);
				console.log(experiences);
			} catch (error) {
				console.error('Error loading data:', error);
				// Handle error appropriately
			}
		})();
	});

	// Watch for changes in selected tags and update filtered experiences
	$effect(() => {
		updateFilteredExperiences();
	});

	function updateFilteredExperiences() {
		if (selectedTags.length === 0) {
			// When no tags are selected, show all experiences
			filteredExperiences = experiences;
			return;
		}

		// Filter experiences based on selected tags
		filteredExperiences = experiences
			.map((company) => {
				// First, filter positions within each company
				const filteredPositions = company.positions.filter((position) =>
					position.tags?.some((tag) => selectedTags.includes(tag))
				);

				// If any positions match, return company with only matching positions
				if (filteredPositions.length > 0) {
					return {
						...company,
						positions: filteredPositions
					};
				}

				// If no positions match, return null
				return null;
			})
			.filter(Boolean) as CompanyExperience[];
	}

	function formatDescription(description: string): string {
		// Split the description into paragraphs
		return description
			.split('\n')
			.map((line) => line.trim())
			.filter((line) => line.length > 0)
			.join('\n');
	}

	function formatDate(date: string): string {
		if (date === 'Present') return date;
		const [year, month] = date.split('-');
		const monthNames = [
			'Jan',
			'Feb',
			'Mar',
			'Apr',
			'May',
			'Jun',
			'Jul',
			'Aug',
			'Sep',
			'Oct',
			'Nov',
			'Dec'
		];
		return `${monthNames[parseInt(month) - 1]} ${year}`;
	}
</script>

<div class="md:w-9/10 mx-auto w-full">
	<div class="max-w-full space-y-12">
		<div class="grid gap-8 md:grid-cols-2 lg:grid-cols-3">
			<!-- About Me Section -->
			<section class="space-y-4 md:col-span-1 lg:col-span-2">
				<h1 class="text-3xl font-bold text-content-primary">About Me</h1>
				<div class="prose prose-lg max-w-none text-content-secondary">
					<p>
						Highly accomplished Information Technology Professional with a strong track record of
						successfully developing and implementing intricate infrastructures and technical
						solutions for renowned industry leaders such as Fujitsu Technology Solutions and Atos IT
						Services.
					</p>
					<br />
					<p>
						Recognized for proficiency in determining system requirements and designing solutions to
						increase organizational productivity and exceed business requirements. Skilled in
						providing effective leadership in fast-paced, deadline-driven environments and known for
						good presentation and communication skills. Backed by exceptional academic credentials,
						including a Master of Business Administration degree in Information Technology
						Management attained from National American University.
					</p>
				</div>
			</section>

			<!-- Right Column: Certifications, Resumes, and Filters -->
			<section class="space-y-8">
				<!-- Certifications Section -->
				<div>
					<h2 class="text-2xl font-bold">Certifications</h2>
					<div class="mt-4 grid grid-cols-3 gap-2">
						{#each certifications as cert}
							<CertificationCard
								imageUrl={cert.imageUrl}
								name={cert.name}
								infoUrl={cert.infoUrl}
								validUntil={cert.validUntil}
							/>
						{/each}
					</div>
				</div>

			</section>
		</div>

		<!-- Experience Section -->
		<div class="grid gap-8 md:grid-cols-2 lg:grid-cols-3">
			<section class="space-y-6 md:col-span-1 lg:col-span-2">
				<h2 class="text-2xl font-bold text-content-primary">Experience</h2>

				<div
					class="relative pl-12 before:absolute before:bottom-0 before:left-0 before:top-0 before:w-1 before:bg-gray-300 dark:before:bg-gray-600"
				>
					{#each filteredExperiences as company}
						<div class="relative mb-12 last:mb-0">
							<!-- Company Timeline Dot -->
							<div
								class="absolute left-[-26px] top-0 z-10 h-5 w-5 rounded-full border-4 border-white bg-blue-600 dark:border-gray-800"
							></div>

							<!-- Company Header -->
							<div class="mb-4 grid grid-cols-12 items-start gap-2">
								<div class="col-span-3 pr-4 text-right text-gray-600 dark:text-gray-400">
									<p class="text-sm font-medium">
										{formatDate(company.startDate)} - {formatDate(company.endDate)}
									</p>
								</div>
								<div class="col-span-9">
									<h3 class="text-2xl font-bold text-content-primary">{company.company}</h3>
								</div>
							</div>

							<!-- Positions -->
							<div class="ml-3">
								{#each company.positions as position}
									<div class="relative grid grid-cols-12 items-start gap-2 pb-8 last:pb-0">
										<!-- Position Timeline Dot -->
										<div
											class="absolute left-[-29px] top-2 z-10 h-3 w-3 rounded-full border-2 border-white bg-blue-400 dark:border-gray-800"
										></div>

										<!-- Position Date -->
										<div class="col-span-3 pr-4 text-right text-gray-600 dark:text-gray-400">
											<p class="text-sm">
												{formatDate(position.startDate)} - {formatDate(position.endDate)}
											</p>
										</div>

										<!-- Position Details -->
										<div
											class="col-span-9 rounded-lg bg-background-alt p-6 shadow-sm transition-colors duration-300 hover:bg-background-light hover:bg-blue-100"
										>
											<h4 class="text-xl font-semibold text-content-primary">{position.title}</h4>

											<!-- Display Position Tags -->
											{#if position.tags && position.tags.length > 0}
												<div class="mt-2 flex flex-wrap gap-1">
													{#each position.tags as tag}
														<span
															class="inline-block rounded-full bg-gray-100 px-2 py-0.5 text-xs font-medium text-gray-800 dark:bg-gray-700 dark:text-gray-200"
														>
															{tag}
														</span>
													{/each}
												</div>
											{/if}

											<div
												class="prose prose-sm mt-2 max-w-none whitespace-pre-wrap text-content-secondary"
											>
												{#each formatDescription(position.description).split('\n') as paragraph}
													{#if paragraph.trim().startsWith('-')}
														<ul class="my-2 ml-4 list-disc">
															<li>{paragraph.substring(1).trim()}</li>
														</ul>
													{:else}
														<p class="my-2">{paragraph}</p>
													{/if}
												{/each}
											</div>
										</div>
									</div>
								{/each}
							</div>
						</div>
					{/each}
					{#if filteredExperiences.length === 0}
						<div class="py-8 text-center">
							<p class="text-lg text-gray-600 dark:text-gray-400">
								No experiences match the selected filters.
							</p>
							<button
								class="mt-2 rounded bg-accent-500 px-4 py-2 text-white transition-colors hover:bg-accent-600"
								onclick={() => {
									selectedTags = [];
								}}
							>
								Clear filters
							</button>
						</div>
					{/if}
				</div>
			</section>
			<section class="space-y-8">	
				<!-- Resumes Section -->
				<div>
					<h2 class="text-2xl font-bold text-content-primary">Resumes</h2>
					<div class="mt-4 flex flex-wrap gap-4">
						{#each resumes as resume}
							<Button href={resume.url} class="bg-blue-500 text-white hover:bg-blue-100">
								Download {resume.title}
							</Button>
						{/each}
					</div>
				</div>
			
				<!-- Tag Filtering Section -->
				<div>
					<h2 class="text-2xl font-bold text-content-primary">Filter Experience</h2>
					<div class="mt-4">
						<FilterTags 
							allTags={allTags} 
							selectedTags={selectedTags} 
							onTagToggle={(tag) => {
								if (selectedTags.includes(tag)) {
									selectedTags = selectedTags.filter(t => t !== tag);
								} else {
									selectedTags = [...selectedTags, tag];
								}
							}}
							onClearFilters={() => {
								selectedTags = [];
							}}
						/>
					</div>
				</div>
			</section>
		</div>
	</div>
</div>
